; HorlogeJC : Heures, minutes secondes
; Alarme : Sortie sur RA4
; Interruption provoque par le timer 'temps rel'
; Comptages des inters Quartz 4096KHz (Fe=1024kHz)
; Prdiviseur par 32 
; Le dbordement du timer provoque une interruption toutes les 8ms
; Il faut 125 interruptions pour faire une seconde
	
;*************************************************************************
			
;Configuration du pic, des registres et appel des macros		
			config cp=non, pwrt=non, wdt=non, osc=xt
			include "registres.h" 	;Les constantes registres
			include "stdmac.h"	;Les macros

;Dfinition des constantes			
CTinter		equ d'125'	;Cte du Nb d'inter pour la seconde(1=8ms)
CTreglage		equ d'20'	;Cte de la frquence de comptage du rglage

Max60		equ d'60'	;Cte valeur max de comptage modulo 60
Max24		equ d'24'	;Cte valeur max de comptage modolo 24
MaxUnite		equ d'10'	;Cte valeur max Units de conversion Bin/Bcd

Aff8LedJaune	equ h'80'	;Cte de commande de l'aff8. Led Jaune
Aff7LedVerte	equ h'70'	;Cte de commande de l'aff7. Led Verte
Aff6		equ h'60'	;Cte de commande de l'aff6.(le +  gauche)          
Aff5		equ h'50'	;Cte de commande de l'afficheur 5	
Aff4		equ h'40'	;Cte de commande de l'afficheur 4
Aff3		equ h'30'	;Cte de commande de l'afficheur 3 
Aff2		equ h'20'	;Cte de commande de l'afficheur 2
Aff1		equ h'10'	;Cte de commande de l'aff1.(le +  droite)

ToucheRA0		equ d'0'	;Cte Bit RA0 de la Raz des secondes
ToucheRA1		equ d'1'	;Cte Bit RA1 de rglage des minutes
ToucheRA2		equ d'2'	;Cte Bit RA2 de rglage des heures
ToucheRA3		equ d'3'	;Cte Bit RA3 de rglage des heures

SortieRA4		equ d'4'	;Cte bit RA4(PORTA)(Led Rouge)

LedVerte		equ d'0'	;Cte Bit 0 de Drapeau
LedJaune		equ d'1'	;Cte Bit 1 de Drapeau

;Rservaton des variables	
			org	0x20,zreg ;zone registre libre (usage gnral)

NBinter		rm	1	;Var. d'inter du timer donnant la seconde
NbTempoReg	rm	1	;Var. pour TempoReg

Secondes		rm	1	;Var. compteur des secondes
Minutes		rm	1	;Var. compteur des minutes
Heures		rm	1	;Var. compteur des heures

DataAff12		rm	1	;Var. pour les afficheurs 1 et 2
DataAff34		rm	1	;Var. pour les afficheurs 3 et 4
DataAff56		rm	1	;Var. pour les afficheurs 5 et 6


Aff6Data		rm	1	;Var. Afficheur 1 (le plus  gauche)
Aff5Data		rm	1	;Var. Afficheur 2
Aff4Data		rm	1	;Var. Afficheur 3 
Aff3Data		rm	1	;Var. Afficheur 4  
Aff2Data		rm	1	;Var. Afficheur 5 
Aff1Data		rm	1	;Var. Afficheur 6 (le plus  droite)

Bin			rm    1	;Var. Nombre Binaire  convertir en Bcd 
BcdUnite		rm	1	;Var. BCD Unit 
BcdDizaine	rm	1	;Var. BCD Dizaine 

Drapeau		rm	1	;Var. LedVerte, LedJaune, etc.
;-------------------Dbut du programme aprs reset------------------------		
			org	0,zprog	;Reset toujours  l'adresse 0
			goto  Init
				
;----------------------Programme d'interruption---------------------------
			org	4,zprog	;Inter toujours  l'adresse 4
			
			decfsz NBinter	;Dcrmente  chaque inter pour seconde
			goto 	Suite		;Si NBinter pas 0 alors suite
			call	Compteur	;Sinon NBinter=0 alors seconde+1
			
			movlf	CTinter,NBinter	;Initialisation du compteur CTinter		
		
Suite		bcf	INTCON,T0IF		;Drapeau d'inter  0
			retfie 			;Retour au programme principal

;Compteur Secondes,Minutes,Heures.
Compteur		incf	Secondes				;Secondes = Secondes+1
			beqc	Secondes,Max60,RazSecondes	;Si Secondes=Max60
			return		;Alors on va  RazSecondes sinon retour
									
RazSecondes	clrf	Secondes				;Raz Secondes
RegMin		incf	Minutes				;Minutes=Minutes+1
			beqc	Minutes,Max60,RazMinutes	;Si Minutes=Max60
			return		;Alors on va  RazMinutes sinon retour
							
RazMinutes	clrf	Minutes		 		;Raz Minutes
RegHeur		incf	Heures		 		;Heures = Heures+1
			beqc	Heures,Max24,RazHeures		;Si Heures=Max24
			return		;Alors on va  RazHeures sinon retour
			
RazHeures		clrf	Heures	; Il est minuit con!	 
			return

;-------------------Programme principal-----------------------------------
;initialisations
Init		bsf	STATUS,RP0	;passer en page 1 (accs  TRIS et OPTION)

			clrf	TRISB				;Tout PORTB en sortie, 
			bcf	TRISA,SortieRA4		;RA4 en sortie
			movlw	(1<<RBPU)|(0<<PS0)|(0<<PS1)|(1<<PS2) ;pas de pull Up
			movwf	OPTIO	    			;sur port B, prdivision:32
			
			bcf	STATUS,RP0			;Repasser en page 0
			
			movlw	(1<<T0IE)|(1<<GIE)	;Validation locale et globale  
			movwf	INTCON 			;pour autoriser l'inter Timer
			movlf	CTinter,NBinter		;Init du dcompte des inters	
			clrf	Secondes			;Raz des variables
			clrf	Minutes
			clrf	Heures
			clrf	PORTB
			clrf	PORTA
			clrf	Drapeau
			bsf	Drapeau,LedVerte
			bsf	Drapeau,LedJaune

;Boucle du programme principal

Boucle		call DetecteTouches		;Dtection touches clavier

;Chargement des Donnes  afficher
			movff Secondes,DataAff12	;Chargement des donnes
			movff Minutes,DataAff34		; afficher
			movff Heures,DataAff56
			call	ConvertAff
			
;Affichage multiplex
			call	Affiche			;Affichage multiplex
			goto	Boucle         		;On reboucle
			
;-----------------------Sous programmes-----------------------------------
;Traitement des valeurs  afficher : conversion et stockage
ConvertAff	movff	DataAff12,Bin	;On charge la valeur  convertir	
			call	BinBcd		;Conversion Binaire/Bcd
			movff	BcdUnite,Aff1Data	  ;Envoi des valeurs Bcd dans les
			movff	BcdDizaine,Aff2Data ;registres d'affichage
			
			movff	DataAff34,Bin		;Pareil que pour les secondes
			call	BinBcd
			movff	BcdUnite,Aff3Data
			movff	BcdDizaine,Aff4Data
			
			movff	DataAff56,Bin		;Pareil 
			call	BinBcd
			movff	BcdUnite,Aff5Data
			movff	BcdDizaine,Aff6Data
			return

;Conversion Binaire/BCD (max = 99, 2 chiffres)
BinBcd		clrf	BcdUnite		;Raz de la variable Unite 
			clrf	BcdDizaine		;Raz de la variable Dizaine
			
Bcl			movf	Bin,W			
			skipz				;Si Bin = 0, on retourne
			goto	IncBcdUnite		;Sinon IncBcdUnite
			return		

IncBcdUnite	incf	BcdUnite		;BcdUnite = BcdUnite+1
			decf	Bin			;On dcrmente Bin		
			beqc	BcdUnite,MaxUnite,RazBcdUnite	;Si BcdUnite=MaxUnite
			goto	Bcl			;on va  RazBcdUnite, sinon Bcl
									
RazBcdUnite	clrf	BcdUnite		;Raz 	BcdUnite
			incf	BcdDizaine		;BcdDizaine = BcdDizaine+1	
			goto	Bcl

;Affichage multiplex
Affiche		movf	Aff1Data,W		;On charge la donne quartet bas
			iorlw	Aff1			;On charge l'afficheur quartet haut
			movwf	PORTB			;On envoie PORTB
			call	T1mS		;On temporise		
		
			movf	Aff2Data,W		 
			iorlw	Aff2			
			movwf	PORTB			
			call	T1mS		

			movf	Aff3Data,W		
			iorlw	Aff3		
			movwf	PORTB			
			call	T1mS	
			
			movf	Aff4Data,W		
			iorlw	Aff4		
			movwf	PORTB			
			call	T1mS	

			movf	Aff5Data,W	
			iorlw	Aff5	
			movwf	PORTB			
			call	T1mS	

			movf	Aff6Data,W		
			iorlw	Aff6		
			movwf	PORTB		
			call	T1mS		
						
			btfss	Drapeau,LedVerte	;Si 1 La Led Verte s'allume
			goto	Saut1			;Sinon Saut1
			movlf	Aff7LedVerte,PORTB	
			call	T1mS		
						
Saut1		btfss	Drapeau,LedJaune	;Si 1 La Led Jaune s'allume
			goto	TempoRgl		;Sinon suite
			movlf	Aff8LedJaune,PORTB	
			call	T1mS

TempoRgl		movf	NbTempoReg		;Tempo pour les rglages
			skipz				;On rpte CTreglage fois 
			goto decreme		;l'affichage
			return

decreme		decf	NbTempoReg		
			goto Affiche

;Dtection des touches
DetecteTouches	btfss	PORTA,ToucheRA0	;Test RA0 : Raz des Secondes 
			call	RazSec		
						
			btfss	PORTA,ToucheRA1   ;Test RA1 : Rglage minute
			call	RegHeures			
			
			btfss	PORTA,ToucheRA2	;Test RA2 : Rglage heure 
			call	RegMinutes		

			btfss	PORTA,ToucheRA3	;Test RA3 : Sortie inverse 
			call	AlarmeForcage	; chaque appuie
			return

;Rglage de la Sortie Alarme
AlarmeForcage	movlf	CTreglage,NbTempoReg ;Init. de la tempo de reglage
			comf	PORTA
			call	TempoRgl
			return
			
;AlarmeOn		bsf	PORTA,SortieRA4	;Sortie   1
			;return
;AlarmeOff		bcf	PORTA,SortieRA4	;Sortie   0
			;return

;Rglage de l'horloge
RazSec		clrf	Secondes
			bcf	Drapeau,LedVerte
			bcf	Drapeau,LedJaune
			return
			
RegMinutes	movlf	CTreglage,NbTempoReg ;Init. de la tempo de reglage
			call	RegMin		   ;Rglage des minutes
			bsf	Drapeau,LedVerte
			return

RegHeures		movlf	CTreglage,NbTempoReg ;Init. de la tempo de reglage
			call	RegHeur		   ;Rglage des heures
			bsf	Drapeau,LedJaune
			return

;Temporisation logicielle pour le multiplexage			

			include "Tempo4.inc"	;Fichier des Tempo 

;-----------------------------Fin------------------------------------------		
			end				;Fin du programme
			
