; This is used for the ASSEMBLER to recalculate certain frequency
; dependant variables. The value of Dev_Freq must be changed to 
; reflect the frequency that the device actually operates at.
;
;Dev_Freq		EQU		D'4000000'			; Device Frequency is 4 MHz
;DB_HI_BYTE		EQU		(HIGH ((( Dev_Freq / 4 ) * 1 / D'1000' ) / 3 ) ) + 1
;LCD_INIT_DELAY	EQU		(HIGH ((( Dev_Freq / 4 ) * D'46' / D'10000' ) / 3 ) ) + 1
;INNER_CNTR		EQU		40					; RAM Location 
;OUTER_CNTR		EQU		41					; RAM Location
;
;T1OSO			EQU		0				; The RC0 / T1OSO / T1CKI
;
;RESET_V			EQU		0x0000			; Address of RESET Vector
;ISR_V			EQU		0x0004			; Address of Interrupt Vector
;PMEM_END		EQU		0x07FF			; Last address in Program Memory
;TABLE_ADDR		EQU		0x0400			; Address where to start Tables
;
;HR_MIN_SW		EQU		0x7				; The switch to select the units
;INC_SW			EQU		0x6				; The switch to increment the selected units
;CLR_MIN_SW		EQU		0x5				; The switch to clear the minutes and seconds
;
;FLAG_REG		EQU		0x020			; Register which contains flag bits
;
;  +------+-------+-------+-----------+-------+-------+----------+---------+
;  |  AM  |  ---  |  ---  | KEY_INPUT |  ---  |  ---  | MIN_UNIT | HR_UNIT |
;  +------+-------+-------+-----------+-------+-------+----------+---------+
;
AM				EQU		0x07			; Flag to specify if AM or PM
;
KEY_INPUT		EQU		0x04			; Flag to specify if doing key inputs
;
MIN_UNIT		EQU		0x01			; Flags to specify which units to operate on
HR_UNIT			EQU		0x00			;  (HRS, MIN, or none)
;
HRS				EQU		0x030			; Holds counter value for HOURS
MIN				EQU		0x031			; Holds counter value for MINUTES
SECS			EQU		0x032			; Holds counter value for SECONDS
MSD				EQU		0x033			; Temporary register, Holds Most Significant Digit of BIN to BCD conversion
LSD				EQU		0x034			; Temporary register, Holds Least Significant Digit of BIN to BCD conversion
TEMP			EQU		0x035			; Temporary register
CHAR			EQU		0x036			; Temporary register, Holds value to send to LCD module.
;
WAIT_CNTR		EQU		0x040			; Counter that holds wait time for key inputs
;
;
; LCD Module commands
;
DISP_ON			EQU		0x00C			; Display on
DISP_ON_C		EQU		0x00E			; Display on, Cursor on
DISP_ON_B		EQU		0x00F			; Display on, Cursor on, Blink cursor
DISP_OFF		EQU		0x008			; Display off
CLR_DISP		EQU		0x001			; Clear the Display
ENTRY_INC		EQU		0x006			;
ENTRY_INC_S		EQU		0x007			;
ENTRY_DEC		EQU		0x004			;
ENTRY_DEC_S		EQU		0x005			;
DD_RAM_ADDR		EQU		0x080			; Least Significant 7-bit are for address
DD_RAM_UL		EQU		0x080			; Upper Left coner of the Display
;

