;Macros pour PIC 16F84

;__________Oprations___________

comc		macro				; Complementer retenue
			movf	STATUS,w
			xorlw	1
			movwf	STATUS
			endm

comw		macro				; Complementer W
			xorlw	0FFH
			endm

addlf		macro				; (Constante,Registre)   Registre = Registre + Constante
			movf	%2,W
			addlw	%1
			movwf	%2
			endm

addwfc		macro				; (Registre)  Registre = Registre + W + Cy
			skipnc
			incfsz %1,F
			addwf	%1,W
			movwf	%1
			endm

andlf		macro				; (Constante,Registre) Registre = Registre & Constante
			movf	%2,W
			andlw	%1
			movwf	%2
			endm

sublf		macro				; (Constante,Registre) Registre = Registre - Constante
			movf	%2,W
			sublw	%1
			movwf	%2
			endm

xorlf		macro				; (Constante,Registre) Registre = Registre ^ Constante
			movf	%2,W
			xorlw	%1
			movwf	%2
			endm

incw		macro				; Incrementer W
			addlw	1
			endm

dec16		macro				; (var16)     Decrementer une variable 16 bits
			decf	%1+1,F
			bnec	%1+1,0xFF,.+2
			decf	%1,F
			endm

inc16		macro				; (var16)     Incrementer une variable 16 bits
			incf	%1+1
			skipnz
			incf	%1
			endm

;_______incrmentation conditionnelle de PC_____

skipc		macro				; sauter si retenue
			btfss	STATUS,C
			endm

skipnc		macro				; sauter si not retenue
			btfsc	STATUS,C
			endm

skipz		macro				; sauter si zero
			btfss	STATUS,Z
			endm

skipnz		macro				; sauter si not zero
			btfsc	STATUS,Z
			endm

skpos		macro				; (reg) sauter si reg >= 0
			btfsc	%1,7
			endm

skneg		macro				; (reg) sauter si reg < 0
			btfss	%1,7
			endm

;_____________branchements_______________

bc			macro				;(Destination) 	brancher si retenue
			skipnc
			goto	%1
			endm

bnc		macro				;(Destination)	brancher si non retenue
			skipc
			goto	%1
			endm

bz			macro				;(Destination)	brancher si zero
			skipnz
			goto	%1
			endm

bnz		macro				;(Destination)	brancher si non nul
			skipz
			goto	%1
			endm

bpl		macro				;(registre,Destination)  brancher si registre >= 0
			btfss	%1,7
			goto	%2
			endm

bmi		macro				;(registre,Destination)  brancher si registre < 0
			btfsc	%1,7
			goto	%2
			endm

brset		macro				;(registre,bit,destination)	brancher si bit  1
			btfsc	%1,%2
			goto	%3
			endm

brclr		macro				;(registre,bit,destination)	brancher si bit  0
			btfss	%1,%2
			goto	%3
			endm

beq		macro				;(R1,R2,Destination) brancher si R1 = R2
			movf	%1,W
			xorwf	%2,W
			skipnz
			goto	%3
			endm

beqc		macro				;(R,Constante,Destination) brancher si R = Constante
			movlw	%2
			xorwf	%1,W
			skipnz
			goto	%3
			endm

bne		macro				;(R1,R2,Destination)  brancher si R1 <> R2
			movf	%1,W
			xorwf	%1,W
			skipz
			goto	%3
			endm

bnec		macro				;(R,Constante,Destination)  brancher si R <> Constante
			movlw	%2
			xorwf	%1,W
			skipz
			goto	%3
			endm

bgt		macro				;(R1,R2,Destination)  brancher si R1 > R2
			movf	%1,W
			subwf	%2,W
			skipc
			goto	%3
			endm

bge		macro				;(R1,R2,Destination)  brancher si R1 >= R2
			movf	%2,W
			subwf	%1,W
			skipnc
			goto	%3
			endm

bgec		macro				;(R1,Cste,Destination)  brancher si R1 >= Cste
			movlw	%2
			subwf	%1,W
			skipnc
			goto	%3
			endm

bgtc		macro				;(R1,Cste,Destination)  brancher si R1 > Cste
			movf	%1,W
			sublw	%2
			skipc
			goto	%3
			endm

blo		macro				;(R1,R2,Destination)  brancher si R1 < R2
			movf	%2,W
			subwf	%1,W
			skipc
			goto	%3
			endm

bls		macro				;(R1,R2,Destination)  brancher si R1 <= R2
			movf	%1,W
			subwf	%2,W
			skipnc
			goto	%3
			endm

blsc		macro				;(R1,Cste,Destination)  brancher si R1 <= Cste
			movf	%1,W
			sublw	%2
			skipnc
			goto	%3
			endm

bloc		macro				;(R1,Cste,Destination)  brancher si R1 < Cste
			movlw	%2
			subwf	%1,W
			skipc
			goto	%3
			endm

;_____________positionnement de bits____________

clrc		macro				; retenue  0
			bcf	STATUS,C
			endm

setc		macro				; retenue  1
			bsf	STATUS,C
			endm

;_____________mouvement de donnes______________

movff		macro				; (Registre1,Registre2)   Registre2 = Registre1
			movf	%1,W
			movwf	%2
			endm

movlf		macro				; (constante,registre)  registre = constante
			movlw	%1
			movwf	%2
			endm

;____________________EEPROM_____________________

lireEE		macro			;(Adresse) lecture d'une donne en EEPROM)
			movlw %1		;La valeur est dans W
			movwf EEADR
			bsf	STATUS,RP0		
			bsf EECON1,ERD
			bcf	STATUS,RP0		
			movf EEDATA,W
			endm

preecrireEE	macro			;(Adresse,donne)prparation de
			movlw	%1		;l'criture d'une donne dans l'EEPROM
			movwf	EEADR		
			movlw %2 		
			movwf EEDATA 	
			endm


;____________________Divers_____________________

bank0		macro				; Selection page 0
			bcf	STATUS,RP0
			endm

bank1		macro				; Selection page 1
			bsf	STATUS,RP0
			endm

dnop		macro				; Double NOP : perdre 2 cycles
			goto	.+1
			endm

save		macro				; sauver W et STATUS (entre interruption)
			movwf	temp_W
			swapf	STATUS,W
			movwf	temp_s
			endm

restore		macro				; restaurer W et STATUS (sortie interruption)
			swapf	temp_s,W
			movwf	STATUS
			swapf	temp_W,F
			swapf	temp_W,W
			endm

test		macro				; (Registre)  Test si (Registre) = 0
			movf	%1,F
			endm
